/// Search and replace using regular expressions (custom dialog)
//
// Example for "Replace with function" flag:
//   What: \d+
//   With: parseInt($0) + 1;
// Or
//   What: \d+
//   With: var n = parseInt($0); return n >= 20 ? 20 : ++n;

var AkelPad=new ActiveXObject("AkelPad.document");
var WshShell=new ActiveXObject("WScript.shell");

//Options
var bShowCountOfChanges=true;
var nSearchStrings=10;

//Buttons
var BT_FINDNEXT   =1
var BT_REPLACE    =2
var BT_REPLACEALL =3

//Direction
var DN_DOWN      =0x00000001
var DN_UP        =0x00000002
var DN_BEGINNING =0x00000004
var DN_SELECTION =0x00000008
var DN_ALLFILES  =0x00000010

//Control IDs
var IDC_FIND           =1001
var IDC_REPLACE        =1002
var IDC_MATCHCASE      =1003
var IDC_MULTILINE      =1004
var IDC_ESCAPESEQ      =1005
var IDC_FUNCTION       =1006
var IDC_FORWARD        =1007
var IDC_BACKWARD       =1008
var IDC_BEGINNING      =1009
var IDC_INSEL          =1010
var IDC_ALLFILES       =1011
var IDC_FIND_BUTTON    =1012
var IDC_REPLACE_BUTTON =1013
var IDC_ALL_BUTTON     =1014
var IDC_CANCEL         =1015
var IDC_STATIC         =-1

//String IDs
var STRID_LOWJSCRIPT   =0
var STRID_WHAT         =1
var STRID_WITH         =2
var STRID_MATCHCASE    =3
var STRID_MULTILINE    =4
var STRID_ESCAPESEQ    =5
var STRID_FUNCTION     =6
var STRID_DIRECTION    =7
var STRID_FORWARD      =8
var STRID_BACKWARD     =9
var STRID_BEGINNING    =10
var STRID_INSEL        =11
var STRID_ALLFILES     =12
var STRID_FINDNEXT     =13
var STRID_REPLACE      =14
var STRID_REPLACEALL   =15
var STRID_CANCEL       =16
var STRID_SYNTAXERROR  =17
var STRID_FINISHED     =18
var STRID_COUNTFILES   =19
var STRID_COUNTCHANGES =20

//Maximum selection length
var PUTFIND_MAXSEL  =16384

//Dialog resize
var DRS_SIZE =0x1  //Resize control
var DRS_MOVE =0x2  //Move control
var DRS_X    =0x4  //X value
var DRS_Y    =0x8  //Y value

var hMainWnd=AkelPad.GetMainWnd();
var oSys=AkelPad.SystemFunction();
var pScriptName=WScript.ScriptName;
var hInstanceDLL=AkelPad.GetInstanceDll();
var bAkelEdit=AkelPad.IsAkelEdit();
var hWndDialog;
var hWndWhat;
var hWndWith;
var hWndStatic;
var hWndCase;
var hWndGlobal;
var hWndMultiline;
var hWndEscSequences;
var hWndReplaceFunction;
var hWndGroup1;
var hWndGroup2;
var hWndDown;
var hWndUp;
var hWndBeginning;
var hWndSelection;
var hWndAllFiles;
var hWndFindNext;
var hWndReplace;
var hWndReplaceAll;
var hWndCancel;
var hWndFocus;
var rcInitDialogRect=[];
var rcCurrentDialogRect=[];
var drs=[];
var hGuiFont;
var lpBuffer;
var pFindIt="";
var pReplaceWith="";
var pReplaceWithEsc;
var lpFindStrings;
var lpReplaceStrings;
var bSensitive=false;
var bMultiline=false;
var bEscSequences=false;
var bReplaceFunction=false;
var nSelStart;
var nSelEnd;
var nDirection=DN_DOWN;
var nFindItLength;
var nSearchResult;
var nButton=0;
var i;
var _TCHAR;
var _TSTR;
var _TSIZE;

if (hMainWnd)
{
  if (ScriptEngineMajorVersion() <= 5 && ScriptEngineMinorVersion() < 5)
  {
    AkelPad.MessageBox(hMainWnd, GetLangString(STRID_LOWJSCRIPT), pScriptName, 48 /*MB_ICONEXCLAMATION*/);
    WScript.Quit();
  }

  if (AkelPad.IsOldWindows())
  {
    _TCHAR="A";
    _TSTR=0 /*DT_ANSI*/;
    _TSIZE=1 /*sizeof(char)*/;
  }
  else
  {
    _TCHAR="W";
    _TSTR=1 /*DT_UNICODE*/;
    _TSIZE=2 /*sizeof(wchar_t)*/;
  }

  if (AkelPad.WindowRegisterClass(pScriptName))
  {
    if (lpBuffer=AkelPad.MemAlloc(256 * _TSIZE))
    {
      //Create dialog
      AkelPad.MemCopy(lpBuffer, pScriptName, _TSTR);
      hWndDialog=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                           0,               //dwExStyle
                           lpBuffer,        //lpClassName
                           0,               //lpWindowName
                           0x90CE0000,      //WS_VISIBLE|WS_POPUP|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_THICKFRAME
                           0,               //x
                           0,               //y
                           392,             //nWidth
                           223,             //nHeight
                           hMainWnd,        //hWndParent
                           0,               //ID
                           hInstanceDLL,    //hInstance
                           DialogCallback); //Script function callback. To use it class must be registered by WindowRegisterClass.
      if (hWndDialog)
      {
        //Message loop
        AkelPad.WindowGetMessage();
      }
      AkelPad.MemFree(lpBuffer);
    }
    AkelPad.WindowUnregisterClass(pScriptName);
  }
}

function DialogCallback(hWnd, uMsg, wParam, lParam)
{
  if (uMsg == 1)  //WM_CREATE
  {
    //Find
    lpFindStrings=new Array(nSearchStrings);

    try
    {
      for (i=0; i < nSearchStrings; ++i)
      {
        lpFindStrings[i]=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Find" + i);
      }
    }
    catch (nError)
    {
    }
    pFindIt=lpFindStrings[0];

    //Replace
    lpReplaceStrings=new Array(nSearchStrings);

    try
    {
      for (i=0; i < nSearchStrings; ++i)
      {
        lpReplaceStrings[i]=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Replace" + i);
      }
    }
    catch (nError)
    {
    }
    pReplaceWith=lpReplaceStrings[0];

    try
    {
      bSensitive=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Sensitive");
      bMultiline=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Multiline");
      bEscSequences=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\EscSequences");
      bReplaceFunction=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\ReplaceFunction");
      nDirection=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Direction");
      rcCurrentDialogRect.right=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\DialogWidth");
      rcCurrentDialogRect.bottom=WshShell.RegRead("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\DialogHeight");
    }
    catch (nError)
    {
    }

    hGuiFont=oSys.Call("gdi32::GetStockObject", 17 /*DEFAULT_GUI_FONT*/);

    //Dialog caption
    AkelPad.MemCopy(lpBuffer, pScriptName, _TSTR);
    oSys.Call("user32::SetWindowText" + _TCHAR, hWnd, lpBuffer);


    ////Static window What

    //Create window
    AkelPad.MemCopy(lpBuffer, "STATIC", _TSTR);
    hWndStatic=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                         0,            //dwExStyle
                         lpBuffer,     //lpClassName
                         0,            //lpWindowName
                         0x50000000,   //WS_VISIBLE|WS_CHILD
                         6,            //x
                         18,           //y
                         33,           //nWidth
                         20,           //nHeight
                         hWnd,         //hWndParent
                         IDC_STATIC,   //ID
                         hInstanceDLL, //hInstance
                         0);           //lpParam
    //Set font and text
    SetWindowFontAndText(hWndStatic, hGuiFont, GetLangString(STRID_WHAT));


    ////Edit window What

    //Create window
    AkelPad.MemCopy(lpBuffer, "COMBOBOX", _TSTR);
    hWndWhat=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                       0,            //dwExStyle
                       lpBuffer,     //lpClassName
                       0,            //lpWindowName
                       0x50210042,   //WS_VISIBLE|WS_CHILD|WS_TABSTOP|WS_VSCROLL|CBS_DROPDOWN|CBS_AUTOHSCROLL
                       41,           //x
                       15,           //y
                       240,          //nWidth
                       160,          //nHeight
                       hWnd,         //hWndParent
                       IDC_FIND,     //ID
                       hInstanceDLL, //hInstance
                       0);           //lpParam
    //Fill combobox
    for (i=0; i < nSearchStrings && lpFindStrings[i]; ++i)
    {
      AkelPad.MemCopy(lpBuffer, lpFindStrings[i], _TSTR);
      AkelPad.SendMessage(hWndWhat, 0x143 /*CB_ADDSTRING*/, 0, lpBuffer);
    }

    //Set font and text
    nSelStart=AkelPad.GetSelStart();
    nSelEnd=AkelPad.GetSelEnd();
    if (nSelStart != nSelEnd && nSelEnd - nSelStart < PUTFIND_MAXSEL && !(nDirection == DN_SELECTION) && !AkelPad.SendMessage(AkelPad.GetEditWnd(), 3127 /*AEM_GETCOLUMNSEL*/, 0, 0))
      SetWindowFontAndText(hWndWhat, hGuiFont, AkelPad.GetSelText());
    else
    {
      SetWindowFontAndText(hWndWhat, hGuiFont, "");
      AkelPad.SendMessage(hWndWhat, 0x14E /*CB_SETCURSEL*/, 0, 0);
    }


    ////Static window With

    //Create window
    AkelPad.MemCopy(lpBuffer, "STATIC", _TSTR);
    hWndStatic=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                         0,            //dwExStyle
                         lpBuffer,     //lpClassName
                         0,            //lpWindowName
                         0x50000000,   //WS_VISIBLE|WS_CHILD
                         6,            //x
                         41,           //y
                         33,           //nWidth
                         20,           //nHeight
                         hWnd,         //hWndParent
                         IDC_STATIC,   //ID
                         hInstanceDLL, //hInstance
                         0);           //lpParam
    //Set font and text
    SetWindowFontAndText(hWndStatic, hGuiFont, GetLangString(STRID_WITH));


    ////Edit window With

    //Create window
    AkelPad.MemCopy(lpBuffer, "COMBOBOX", _TSTR);
    hWndWith=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                       0,            //dwExStyle
                       lpBuffer,     //lpClassName
                       0,            //lpWindowName
                       0x50210042,   //WS_VISIBLE|WS_CHILD|WS_TABSTOP|WS_VSCROLL|CBS_DROPDOWN|CBS_AUTOHSCROLL
                       41,           //x
                       37,           //y
                       240,          //nWidth
                       160,          //nHeight
                       hWnd,         //hWndParent
                       IDC_REPLACE,  //ID
                       hInstanceDLL, //hInstance
                       0);           //lpParam
    //Fill combobox
    for (i=0; i < nSearchStrings && lpReplaceStrings[i]; ++i)
    {
      AkelPad.MemCopy(lpBuffer, lpReplaceStrings[i], _TSTR);
      AkelPad.SendMessage(hWndWith, 0x143 /*CB_ADDSTRING*/, 0, lpBuffer);
    }

    //Set font and text
    SetWindowFontAndText(hWndWith, hGuiFont, "");
    AkelPad.SendMessage(hWndWith, 0x14E /*CB_SETCURSEL*/, 0, 0);


    ////Checkbox Sensitive

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndCase=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                       0,             //dwExStyle
                       lpBuffer,      //lpClassName
                       0,             //lpWindowName
                       0x50010003,    //WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_AUTOCHECKBOX
                       14,            //x
                       70,            //y
                       158,           //nWidth
                       20,            //nHeight
                       hWnd,          //hWndParent
                       IDC_MATCHCASE, //ID
                       hInstanceDLL,  //hInstance
                       0);            //lpParam
    //Set font and text
    SetWindowFontAndText(hWndCase, hGuiFont, GetLangString(STRID_MATCHCASE));


    ////Checkbox Multiline

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndMultiline=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,             //dwExStyle
                            lpBuffer,      //lpClassName
                            0,             //lpWindowName
                            0x50010003,    //WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_AUTOCHECKBOX
                            14,            //x
                            91,            //y
                            158,           //nWidth
                            20,            //nHeight
                            hWnd,          //hWndParent
                            IDC_MULTILINE, //ID
                            hInstanceDLL,  //hInstance
                            0);            //lpParam
    //Set font and text
    SetWindowFontAndText(hWndMultiline, hGuiFont, GetLangString(STRID_MULTILINE));


    ////Checkbox Esc-sequences

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndEscSequences=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                               0,             //dwExStyle
                               lpBuffer,      //lpClassName
                               0,             //lpWindowName
                               0x50010003,    //WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_AUTOCHECKBOX
                               14,            //x
                               112,           //y
                               158,           //nWidth
                               20,            //nHeight
                               hWnd,          //hWndParent
                               IDC_ESCAPESEQ, //ID
                               hInstanceDLL,  //hInstance
                               0);            //lpParam
    //Set font and text
    SetWindowFontAndText(hWndEscSequences, hGuiFont, GetLangString(STRID_ESCAPESEQ));


    ////Checkbox Replace with function

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndReplaceFunction=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                                  0,            //dwExStyle
                                  lpBuffer,     //lpClassName
                                  0,            //lpWindowName
                                  0x50010003,   //WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_AUTOCHECKBOX
                                  14,           //x
                                  133,          //y
                                  158,          //nWidth
                                  20,           //nHeight
                                  hWnd,         //hWndParent
                                  IDC_FUNCTION, //ID
                                  hInstanceDLL, //hInstance
                                  0);           //lpParam
    //Set font and text
    SetWindowFontAndText(hWndReplaceFunction, hGuiFont, GetLangString(STRID_FUNCTION));


    ////GroupBox 1

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndGroup1=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                         0,            //dwExStyle
                         lpBuffer,     //lpClassName
                         0,            //lpWindowName
                         0x50000007,   //WS_VISIBLE|WS_CHILD|BS_GROUPBOX
                         182,          //x
                         67,           //y
                         99,           //nWidth
                         94,           //nHeight
                         hWnd,         //hWndParent
                         IDC_STATIC,   //ID
                         hInstanceDLL, //hInstance
                         0);           //lpParam
    //Set font and text
    SetWindowFontAndText(hWndGroup1, hGuiFont, GetLangString(STRID_DIRECTION));


    ////Radiobutton Down

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndDown=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                       0,            //dwExStyle
                       lpBuffer,     //lpClassName
                       0,            //lpWindowName
                       0x50000009,   //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                       189,          //x
                       83,           //y
                       90,           //nWidth
                       16,           //nHeight
                       hWnd,         //hWndParent
                       IDC_FORWARD,  //ID
                       hInstanceDLL, //hInstance
                       0);           //lpParam
    //Set font and text
    SetWindowFontAndText(hWndDown, hGuiFont, GetLangString(STRID_FORWARD));


    ////Radiobutton Up

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndUp=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                     0,            //dwExStyle
                     lpBuffer,     //lpClassName
                     0,            //lpWindowName
                     0x50000009,   //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                     189,          //x
                     101,          //y
                     90,           //nWidth
                     16,           //nHeight
                     hWnd,         //hWndParent
                     IDC_BACKWARD, //ID
                     hInstanceDLL, //hInstance
                     0);           //lpParam
    //Set font and text
    SetWindowFontAndText(hWndUp, hGuiFont, GetLangString(STRID_BACKWARD));


    ////Radiobutton Beginning

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndBeginning=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,             //dwExStyle
                            lpBuffer,      //lpClassName
                            0,             //lpWindowName
                            0x50000009,    //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            189,           //x
                            119,           //y
                            90,            //nWidth
                            16,            //nHeight
                            hWnd,          //hWndParent
                            IDC_BEGINNING, //ID
                            hInstanceDLL,  //hInstance
                            0);            //lpParam
    //Set font and text
    SetWindowFontAndText(hWndBeginning, hGuiFont, GetLangString(STRID_BEGINNING));


    ////Radiobutton Selection

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndSelection=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,            //dwExStyle
                            lpBuffer,     //lpClassName
                            0,            //lpWindowName
                            0x50000009,   //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            189,          //x
                            137,          //y
                            90,           //nWidth
                            16,           //nHeight
                            hWnd,         //hWndParent
                            IDC_INSEL,    //ID
                            hInstanceDLL, //hInstance
                            0);           //lpParam
    //Set font and text
    SetWindowFontAndText(hWndSelection, hGuiFont, GetLangString(STRID_INSEL));


    if (AkelPad.IsMDI())
    {
      ////Radiobutton AllFiles

      //Create window
      AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
      hWndAllFiles=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                             0,            //dwExStyle
                             lpBuffer,     //lpClassName
                             0,            //lpWindowName
                             0x50000009,   //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                             189,          //x
                             164,          //y
                             90,           //nWidth
                             16,           //nHeight
                             hWnd,         //hWndParent
                             IDC_ALLFILES, //ID
                             hInstanceDLL, //hInstance
                             0);           //lpParam
      //Set font and text
      SetWindowFontAndText(hWndAllFiles, hGuiFont, GetLangString(STRID_ALLFILES));


      ////GroupBox 2

      //Create window
      AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
      hWndGroup2=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                           0,            //dwExStyle
                           lpBuffer,     //lpClassName
                           0,            //lpWindowName
                           0x50000007,   //WS_VISIBLE|WS_CHILD|BS_GROUPBOX
                           182,          //x
                           153,          //y
                           99,           //nWidth
                           31,           //nHeight
                           hWnd,         //hWndParent
                           IDC_STATIC,   //ID
                           hInstanceDLL, //hInstance
                           0);           //lpParam
      //Set font and text
      SetWindowFontAndText(hWndGroup2, hGuiFont, "");
    }


    ////Button window FindNext

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndFindNext=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                           0,               //dwExStyle
                           lpBuffer,        //lpClassName
                           0,               //lpWindowName
                           0x50010001,      //WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_DEFPUSHBUTTON
                           294,             //x
                           10,              //y
                           81,              //nWidth
                           23,              //nHeight
                           hWnd,            //hWndParent
                           IDC_FIND_BUTTON, //ID
                           hInstanceDLL,    //hInstance
                           0);              //lpParam
    //Set font and text
    SetWindowFontAndText(hWndFindNext, hGuiFont, GetLangString(STRID_FINDNEXT));


    ////Button window Replace

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndReplace=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                          0,                  //dwExStyle
                          lpBuffer,           //lpClassName
                          0,                  //lpWindowName
                          0x50010000,         //WS_VISIBLE|WS_CHILD|WS_TABSTOP
                          294,                //x
                          37,                 //y
                          81,                 //nWidth
                          23,                 //nHeight
                          hWnd,               //hWndParent
                          IDC_REPLACE_BUTTON, //ID
                          hInstanceDLL,       //hInstance
                          0);                 //lpParam
    //Set font and text
    SetWindowFontAndText(hWndReplace, hGuiFont, GetLangString(STRID_REPLACE));


    ////Button window ReplaceAll

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndReplaceAll=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                             0,              //dwExStyle
                             lpBuffer,       //lpClassName
                             0,              //lpWindowName
                             0x50010000,     //WS_VISIBLE|WS_CHILD|WS_TABSTOP
                             294,            //x
                             63,             //y
                             81,             //nWidth
                             23,             //nHeight
                             hWnd,           //hWndParent
                             IDC_ALL_BUTTON, //ID
                             hInstanceDLL,   //hInstance
                             0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndReplaceAll, hGuiFont, GetLangString(STRID_REPLACEALL));


    ////Button window Cancel

    //Create window
    AkelPad.MemCopy(lpBuffer, "BUTTON", _TSTR);
    hWndCancel=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                         0,            //dwExStyle
                         lpBuffer,     //lpClassName
                         0,            //lpWindowName
                         0x50010000,   //WS_VISIBLE|WS_CHILD|WS_TABSTOP
                         294,          //x
                         89,           //y
                         81,           //nWidth
                         23,           //nHeight
                         hWnd,         //hWndParent
                         IDC_CANCEL,   //ID
                         hInstanceDLL, //hInstance
                         0);           //lpParam
    //Set font and text
    SetWindowFontAndText(hWndCancel, hGuiFont, GetLangString(STRID_CANCEL));


    //Checks
    if (bSensitive) AkelPad.SendMessage(hWndCase, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);
    if (bMultiline) AkelPad.SendMessage(hWndMultiline, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);
    if (bEscSequences) AkelPad.SendMessage(hWndEscSequences, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);
    if (bReplaceFunction)
    {
      AkelPad.SendMessage(hWndReplaceFunction, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);
      oSys.Call("user32::EnableWindow", hWndEscSequences, false);
    }

    if (nDirection == DN_ALLFILES)
    {
      if (AkelPad.IsMDI())
        AkelPad.SendMessage(hWndAllFiles, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);
      else
        nDirection=DN_DOWN;
    }
    else if (nDirection == DN_BEGINNING) AkelPad.SendMessage(hWndBeginning, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);
    else if (nDirection == DN_SELECTION) AkelPad.SendMessage(hWndSelection, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);

    if (nDirection == DN_DOWN) AkelPad.SendMessage(hWndDown, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);
    else if (nDirection == DN_UP) AkelPad.SendMessage(hWndUp, 241 /*BM_SETCHECK*/, 1 /*BST_CHECKED*/, 0);

    drs=[[hWndWhat,       DRS_SIZE|DRS_X],
         [hWndWith,       DRS_SIZE|DRS_X],
         [hWndGroup1,     DRS_MOVE|DRS_X],
         [hWndGroup2,     DRS_MOVE|DRS_X],
         [hWndDown,       DRS_MOVE|DRS_X],
         [hWndUp,         DRS_MOVE|DRS_X],
         [hWndBeginning,  DRS_MOVE|DRS_X],
         [hWndSelection,  DRS_MOVE|DRS_X],
         [hWndAllFiles,   DRS_MOVE|DRS_X],
         [hWndFindNext,   DRS_MOVE|DRS_X],
         [hWndReplace,    DRS_MOVE|DRS_X],
         [hWndReplaceAll, DRS_MOVE|DRS_X],
         [hWndCancel,     DRS_MOVE|DRS_X],
         [0, 0]];

    //Center dialog
    CenterWindow(hMainWnd, hWnd);
  }
  else if (uMsg == 7)  //WM_SETFOCUS
  {
    oSys.Call("user32::SetFocus", hWndWhat);
  }
  else if (uMsg == 256)  //WM_KEYDOWN
  {
    if (wParam == 27)  //VK_ESCAPE
    {
      //Escape key pushes Cancel button
      oSys.Call("user32::PostMessage" + _TCHAR, hWndDialog, 273 /*WM_COMMAND*/, IDC_CANCEL, 0);
    }
    else if (wParam == 13)  //VK_RETURN
    {
      //Return key pushes OK button
      oSys.Call("user32::PostMessage" + _TCHAR, hWndDialog, 273 /*WM_COMMAND*/, IDC_FIND_BUTTON, 0);
    }
  }
  else if (uMsg == 273)  //WM_COMMAND
  {
    if ((wParam & 0xffff) == IDC_FIND)
    {
      if ((wParam >> 16) == 1 /*CBN_SELCHANGE*/)
      {
        i=AkelPad.SendMessage(hWndWhat, 0x147 /*CB_GETCURSEL*/, 0, 0);
        nFindItLength=AkelPad.SendMessage(hWndWhat, 0x149 /*CB_GETLBTEXTLEN*/, i, 0);
      }
      else
      {
        nFindItLength=oSys.Call("user32::GetWindowTextLength" + _TCHAR, hWndWhat);
      }

      if (nFindItLength)
      {
        oSys.Call("user32::EnableWindow", hWndFindNext, true);
        oSys.Call("user32::EnableWindow", hWndReplace, true);
        oSys.Call("user32::EnableWindow", hWndReplaceAll, true);
      }
      else
      {
        oSys.Call("user32::EnableWindow", hWndFindNext, false);
        oSys.Call("user32::EnableWindow", hWndReplace, false);
        oSys.Call("user32::EnableWindow", hWndReplaceAll, false);
      }
    }
    else if ((wParam & 0xffff) == IDC_MATCHCASE ||
             (wParam & 0xffff) == IDC_MULTILINE ||
             (wParam & 0xffff) == IDC_ESCAPESEQ ||
             (wParam & 0xffff) == IDC_FUNCTION)
    {
      if ((wParam & 0xffff) == IDC_MATCHCASE)
        bSensitive=AkelPad.SendMessage(hWndCase, 240 /*BM_GETCHECK*/, 0, 0);
      else if ((wParam & 0xffff) == IDC_MULTILINE)
        bMultiline=AkelPad.SendMessage(hWndMultiline, 240 /*BM_GETCHECK*/, 0, 0);
      else if ((wParam & 0xffff) == IDC_ESCAPESEQ)
        bEscSequences=AkelPad.SendMessage(hWndEscSequences, 240 /*BM_GETCHECK*/, 0, 0);
      else if ((wParam & 0xffff) == IDC_FUNCTION)
      {
        bReplaceFunction=AkelPad.SendMessage(hWndReplaceFunction, 240 /*BM_GETCHECK*/, 0, 0);
        oSys.Call("user32::EnableWindow", hWndEscSequences, !bReplaceFunction);
      }
    }
    else if ((wParam & 0xffff) == IDC_FORWARD ||
             (wParam & 0xffff) == IDC_BACKWARD ||
             (wParam & 0xffff) == IDC_BEGINNING ||
             (wParam & 0xffff) == IDC_INSEL ||
             (wParam & 0xffff) == IDC_ALLFILES)
    {
      if (nDirection & DN_ALLFILES)
        AkelPad.SendMessage(hWndAllFiles, 243 /*BM_SETSTATE*/, false, 0);
      else if (nDirection & DN_BEGINNING)
        AkelPad.SendMessage(hWndBeginning, 243 /*BM_SETSTATE*/, false, 0);

      if ((wParam & 0xffff) == IDC_FORWARD)
        nDirection=DN_DOWN;
      else if ((wParam & 0xffff) == IDC_BACKWARD)
        nDirection=DN_UP;
      else if ((wParam & 0xffff) == IDC_BEGINNING)
        nDirection=DN_BEGINNING;
      else if ((wParam & 0xffff) == IDC_INSEL)
        nDirection=DN_SELECTION;
      else if ((wParam & 0xffff) == IDC_ALLFILES)
        nDirection=DN_ALLFILES;
    }
    else if ((wParam & 0xffff) == IDC_FIND_BUTTON ||
             (wParam & 0xffff) == IDC_REPLACE_BUTTON ||
             (wParam & 0xffff) == IDC_ALL_BUTTON)
    {
      if ((wParam & 0xffff) == IDC_FIND_BUTTON)
        nButton=BT_FINDNEXT;
      else if ((wParam & 0xffff) == IDC_REPLACE_BUTTON)
        nButton=BT_REPLACE;
      else if ((wParam & 0xffff) == IDC_ALL_BUTTON)
        nButton=BT_REPLACEALL;

      //Find
      oSys.Call("user32::GetWindowText" + _TCHAR, hWndWhat, lpBuffer, 256);
      pFindIt=AkelPad.MemRead(lpBuffer, _TSTR);

      if (nSearchStrings)
      {
        for (i=0; i < nSearchStrings; ++i)
        {
          if (lpFindStrings[i] == pFindIt)
          {
            AkelPad.SendMessage(hWndWhat, 0x144 /*CB_DELETESTRING*/, i, 0);
            lpFindStrings.splice(i, 1);
          }
        }
        lpFindStrings.unshift(pFindIt);
        if (lpFindStrings.length > nSearchStrings)
          lpFindStrings.pop();

        AkelPad.MemCopy(lpBuffer, pFindIt, _TSTR);
        AkelPad.SendMessage(hWndWhat, 0x14A /*CB_INSERTSTRING*/, 0, lpBuffer);
        AkelPad.SendMessage(hWndWhat, 0x14E /*CB_SETCURSEL*/, 0, 0);
      }

      //Replace
      oSys.Call("user32::GetWindowText" + _TCHAR, hWndWith, lpBuffer, 256);
      pReplaceWith=AkelPad.MemRead(lpBuffer, _TSTR);

      if (nSearchStrings)
      {
        for (i=0; i < nSearchStrings; ++i)
        {
          if (lpReplaceStrings[i] == pReplaceWith)
          {
            AkelPad.SendMessage(hWndWith, 0x144 /*CB_DELETESTRING*/, i, 0);
            lpReplaceStrings.splice(i, 1);
          }
        }
        lpReplaceStrings.unshift(pReplaceWith);
        if (lpReplaceStrings.length > nSearchStrings)
          lpReplaceStrings.pop();

        AkelPad.MemCopy(lpBuffer, pReplaceWith, _TSTR);
        AkelPad.SendMessage(hWndWith, 0x14A /*CB_INSERTSTRING*/, 0, lpBuffer);
        AkelPad.SendMessage(hWndWith, 0x14E /*CB_SETCURSEL*/, 0, 0);
      }

      pReplaceWithEsc=pReplaceWith;
      if (bReplaceFunction)
      {
        //Replace with function
        if (!/(^|[^\w.])return\s+\S/.test(pReplaceWithEsc))
          pReplaceWithEsc="return " + pReplaceWithEsc;
        pReplaceWithEsc='var args={}, l=arguments.length;'
                      + 'for (var i=0; i < l; ++i)\n'
                      + '  args["$" + i]=arguments[i];\n'
                      + 'args.offset=arguments[l - 2];\n'
                      + 'args.s=arguments[l - 1];\n'
                      + 'with (args)\n'
                      + '{\n'
                      +    pReplaceWithEsc
                      + '\n}';
        pReplaceWithEsc=new Function(pReplaceWithEsc);
      }
      else if (bEscSequences)
      {
        //Esc-sequences
        pReplaceWithEsc=pReplaceWithEsc.replace(/\\\\/g, "\0");
        if (pReplaceWithEsc.search(/\\[^rnt]/g) != -1)
        {
          AkelPad.MessageBox(hWndDialog, GetLangString(STRID_SYNTAXERROR), pScriptName, 16 /*MB_ICONERROR*/);
          return 0;
        }
        pReplaceWithEsc=pReplaceWithEsc.replace(/(?:\\r\\n|\\r|\\n)/g, "\n");
        pReplaceWithEsc=pReplaceWithEsc.replace(/\\t/g, "\t");
        pReplaceWithEsc=pReplaceWithEsc.replace(/\0/g, "\\");
      }

      hWndFocus=oSys.Call("user32::GetFocus");
      if (nButton == BT_REPLACEALL)
        oSys.Call("user32::EnableWindow", hWndReplaceAll, false);

      nSearchResult=SearchReplace();

      if (nButton == BT_REPLACEALL)
        oSys.Call("user32::EnableWindow", hWndReplaceAll, true);
      oSys.Call("user32::SetFocus", hWndFocus);

      if (nSearchResult == -1)
      {
        if (nDirection & DN_ALLFILES)
        {
          AkelPad.SendMessage(hWndAllFiles, 243 /*BM_SETSTATE*/, false, 0);
          nDirection&=~DN_DOWN;
        }
        else if (nDirection & DN_BEGINNING)
        {
          AkelPad.SendMessage(hWndBeginning, 243 /*BM_SETSTATE*/, false, 0);
          nDirection&=~DN_DOWN;
        }
      }
      else
      {
        if (nDirection == DN_ALLFILES)
        {
          AkelPad.SendMessage(hWndAllFiles, 243 /*BM_SETSTATE*/, true, 0);
          nDirection|=DN_DOWN;
        }
        else if (nDirection == DN_BEGINNING)
        {
          AkelPad.SendMessage(hWndBeginning, 243 /*BM_SETSTATE*/, true, 0);
          nDirection|=DN_DOWN;
        }
      }
    }
    else if ((wParam & 0xffff) == IDC_CANCEL)
    {
      oSys.Call("user32::PostMessage" + _TCHAR, hWndDialog, 16 /*WM_CLOSE*/, 0, 0);
    }
  }
  else if (uMsg == 16)  //WM_CLOSE
  {
    if (nDirection != DN_DOWN) nDirection&=~DN_DOWN;

    for (i=0; i < nSearchStrings && lpFindStrings[i]; ++i)
      WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Find" + i, lpFindStrings[i], "REG_SZ");
    for (i=0; i < nSearchStrings && lpReplaceStrings[i]; ++i)
      WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Replace" + i, lpReplaceStrings[i], "REG_SZ");
    WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Sensitive", bSensitive, "REG_DWORD");
    WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Multiline", bMultiline, "REG_DWORD");
    WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\EscSequences", bEscSequences, "REG_DWORD");
    WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\ReplaceFunction", bReplaceFunction, "REG_DWORD");
    WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\Direction", nDirection, "REG_DWORD");
    WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\DialogWidth", rcCurrentDialogRect.right, "REG_DWORD");
    WshShell.RegWrite("HKCU\\Software\\Akelsoft\\AkelPad\\Plugs\\Scripts\\SearchReplace\\DialogHeight", rcCurrentDialogRect.bottom, "REG_DWORD");

    //Destroy dialog
    oSys.Call("user32::DestroyWindow", hWnd);
  }
  else if (uMsg == 2)  //WM_DESTROY
  {
    //Exit message loop
    oSys.Call("user32::PostQuitMessage", 0);
  }
  DialogResizeMessages(drs, rcInitDialogRect, rcCurrentDialogRect, hWnd, uMsg, wParam, lParam);

  return 0;
}

function DialogResizeMessages(drs, rcInitRect, rcCurRect, hDlg, uMsg, wParam, lParam)
{
  if (uMsg == 1) //WM_CREATE
  {
    var rcTemplate=[];

    GetWindowPos(hDlg, 0, rcInitRect);

    rcTemplate.left=rcCurRect.left;
    rcTemplate.top=rcCurRect.top;
    rcTemplate.right=rcCurRect.right;
    rcTemplate.bottom=rcCurRect.bottom;

    rcCurRect.left=rcInitRect.left;
    rcCurRect.top=rcInitRect.top;
    rcCurRect.right=rcInitRect.right;
    rcCurRect.bottom=rcInitRect.bottom;

    if (rcTemplate.right && rcTemplate.bottom)
    {
      rcTemplate.left=rcInitRect.left + (rcInitRect.right - rcTemplate.right) / 2;
      rcTemplate.top=rcInitRect.top + (rcInitRect.bottom - rcTemplate.bottom) / 2;
      oSys.Call("user32::SetWindowPos", hDlg, 0, rcTemplate.left, rcTemplate.top, rcTemplate.right, rcTemplate.bottom, 0x4 /*SWP_NOZORDER*/);
    }
  }
  else if (uMsg == 36) //WM_GETMINMAXINFO
  {
    AkelPad.MemCopy(lParam + 24, rcInitRect.right, 3 /*DT_DWORD*/); //ptMinTrackSize.x
    AkelPad.MemCopy(lParam + 28, rcInitRect.bottom, 3 /*DT_DWORD*/); //ptMinTrackSize.y

    AkelPad.MemCopy(lParam + 36, rcInitRect.bottom, 3 /*DT_DWORD*/); //ptMaxTrackSize.y
  }
  else if (uMsg == 5) //WM_SIZE
  {
    if (lParam)
    {
      var rcTemplate=[];
      var rcControl=[];
      var pt=[];
      var dwFlags;
      var i=0;

      GetWindowPos(hDlg, 0, rcTemplate);
      pt.x=rcTemplate.right - rcCurRect.right;
      pt.y=rcTemplate.bottom - rcCurRect.bottom;
      rcCurRect.left=rcTemplate.left;
      rcCurRect.top=rcTemplate.top;
      rcCurRect.right=rcTemplate.right;
      rcCurRect.bottom=rcTemplate.bottom;

      for (i=0; drs[i][0]; ++i)
      {
        if (drs[i][0])
        {
          dwFlags=0;
          if (drs[i][1] & DRS_SIZE)
            dwFlags|=0x2 /*SWP_NOMOVE*/;
          else if (drs[i][1] & DRS_MOVE)
            dwFlags|=0x1 /*SWP_NOSIZE*/;
          GetWindowPos(drs[i][0], hDlg, rcControl);
          oSys.Call("user32::SetWindowPos", drs[i][0], 0, rcControl.left + ((drs[i][1] & DRS_X)?pt.x:0), rcControl.top + ((drs[i][1] & DRS_Y)?pt.y:0), rcControl.right + ((drs[i][1] & DRS_X)?pt.x:0), rcControl.bottom + ((drs[i][1] & DRS_Y)?pt.y:0), dwFlags|0x4 /*SWP_NOZORDER*/);
        }
      }
      oSys.Call("user32::InvalidateRect", hDlg, 0, true);
    }
  }
  else if (uMsg == 15) //WM_PAINT
  {
    var ps;
    var rcGrip=[];
    var lpGrip;
    var hDC;

    if (ps=AkelPad.MemAlloc(64 /*sizeof(PAINTSTRUCT)*/))
    {
      if (hDC=oSys.Call("user32::BeginPaint", hDlg, ps))
      {
        if (lpGrip=AkelPad.MemAlloc(16 /*sizeof(RECT)*/))
        {
          if (oSys.Call("user32::GetClientRect", hDlg, lpGrip))
          {
            RectToArray(lpGrip, rcGrip);
            rcGrip.left=rcGrip.right - oSys.Call("user32::GetSystemMetrics", 2 /*SM_CXVSCROLL*/);
            rcGrip.top=rcGrip.bottom - oSys.Call("user32::GetSystemMetrics", 20 /*SM_CYVSCROLL*/);
            ArrayToRect(rcGrip, lpGrip);

            oSys.Call("user32::DrawFrameControl", hDC, lpGrip, 3 /*DFC_SCROLL*/, 0x8 /*DFCS_SCROLLSIZEGRIP*/);
          }
          AkelPad.MemFree(lpGrip);
        }
        oSys.Call("user32::EndPaint", hDlg, ps);
      }
      AkelPad.MemFree(ps);
    }
  }
}

function SearchReplace()
{
  var hWndInitialEdit;
  var hWndCurrentEdit;
  var oPattern;
  var lpArray;
  var pSelText;
  var pResult;
  var nInitialSelStart;
  var nInitialSelEnd;
  var nSelStart;
  var nSelEnd;
  var lpInitialScroll;
  var nMatches=-1;
  var nChanges=0;
  var nChangedFiles=0;
  var nError;
  var nResult=-1;
  var i;

  hWndInitialEdit=AkelPad.GetEditWnd();
  hWndCurrentEdit=hWndInitialEdit;
  oPattern=new RegExp(pFindIt, (bSensitive?"":"i") + (nButton == BT_REPLACEALL || nDirection & DN_UP?"g":"") + (bMultiline?"m":""));

  while (1)
  {
    nInitialSelStart=AkelPad.GetSelStart();
    nInitialSelEnd=AkelPad.GetSelEnd();

    if (nButton == BT_REPLACE)
    {
      if (nInitialSelStart != nInitialSelEnd)
      {
        pSelText=AkelPad.GetSelText();

        if (lpArray=pSelText.match(oPattern))
        {
          if (lpArray.index == 0 && lpArray[0].length == (nInitialSelEnd - nInitialSelStart))
          {
            pResult=pSelText.replace(oPattern, pReplaceWithEsc);
            AkelPad.ReplaceSel(pResult);

            nInitialSelStart=AkelPad.GetSelStart();
            nInitialSelEnd=AkelPad.GetSelEnd();
          }
        }
      }
      nButton=BT_FINDNEXT;
    }

    if (nDirection & DN_DOWN)
    {
      if (nButton == BT_FINDNEXT)
      {
        nSelStart=nInitialSelEnd;
        nSelEnd=-1;
      }
      else
      {
        nSelStart=nInitialSelStart;
        nSelEnd=-1;
      }
    }
    else if (nDirection & DN_UP)
    {
      if (nButton == BT_FINDNEXT)
      {
        nSelStart=0;
        nSelEnd=nInitialSelStart;
      }
      else
      {
        nSelStart=0;
        nSelEnd=nInitialSelEnd;
      }
    }
    else if (nDirection & DN_BEGINNING)
    {
      nSelStart=0;
      nSelEnd=-1;
    }
    else if (nDirection & DN_SELECTION)
    {
      nSelStart=nInitialSelStart;
      nSelEnd=nInitialSelEnd;
    }
    else if (nDirection & DN_ALLFILES)
    {
      nSelStart=0;
      nSelEnd=-1;
    }
    lpInitialScroll=SaveScroll(hWndCurrentEdit);
    SetRedraw(hWndCurrentEdit, false);

    try
    {
      if (bAkelEdit) ScrollLock(hWndCurrentEdit, true);

      if (nSelStart != nInitialSelStart || nSelEnd != nInitialSelEnd)
      {
        AkelPad.SetSel(nSelStart, nSelEnd);
        nSelStart=AkelPad.GetSelStart();
        nSelEnd=AkelPad.GetSelEnd();
      }
      pSelText=AkelPad.GetSelText(2 /*\n*/);
      if (!bAkelEdit)
        pSelText=pSelText.replace(/\r/g, "\n");

      if (bAkelEdit) ScrollLock(hWndCurrentEdit, false);

      if (nButton == BT_FINDNEXT)
      {
        if (lpArray=pSelText.match(oPattern))
        {
          if (bAkelEdit) ScrollLock(hWndCurrentEdit, true);

          if (nDirection & DN_UP)
          {
            for (i=0; lpArray[i]; ++i);
            AkelPad.SetSel(nSelStart + (lpArray.lastIndex - lpArray[i - 1].length), nSelStart + lpArray.lastIndex);
          }
          else
          {
            AkelPad.SetSel(nSelStart + lpArray.index, nSelStart + lpArray.index + lpArray[0].length);
          }

          if (bAkelEdit)
          {
            ScrollLock(hWndCurrentEdit, false);
            ScrollCaret(hWndCurrentEdit);
          }
          SetRedraw(hWndCurrentEdit, true);
          nResult=AkelPad.GetSelStart();
        }
        else
        {
          AkelPad.SetSel(nInitialSelStart, nInitialSelEnd);
          RestoreScroll(hWndCurrentEdit, lpInitialScroll);
          SetRedraw(hWndCurrentEdit, true);

          if (nDirection & DN_ALLFILES)
          {
            //Next MDI frame
            AkelPad.SendMessage(hMainWnd, 273 /*WM_COMMAND*/, 4404 /*IDM_NONMENU_MDINEXT*/, 0);
            hWndCurrentEdit=AkelPad.GetEditWnd();
            if (hWndCurrentEdit != hWndInitialEdit)
            {
              AkelPad.SetSel(0, 0);
              continue;
            }
          }
          AkelPad.MessageBox(hWndDialog, GetLangString(STRID_FINISHED), pScriptName, 64 /*MB_ICONINFORMATION*/);
        }
      }
      else if (nButton == BT_REPLACEALL)
      {
        if (bShowCountOfChanges)
        {
          nMatches=pSelText.match(oPattern);
          nMatches=nMatches?nMatches.length:0;
          nChanges+=nMatches;
          ++nChangedFiles;
        }

        if (nMatches)
        {
          pResult=pSelText.replace(oPattern, pReplaceWithEsc);

          if (bAkelEdit)
          {
            if (nDirection & DN_SELECTION)
            {
              dwOptions=AkelPad.SendMessage(hWndCurrentEdit, 3227 /*AEM_GETOPTIONS*/, 0, 0);
              if (!(dwOptions & 0x40 /*AECO_PASTESELECTCOLUMN*/))
                AkelPad.SendMessage(hWndCurrentEdit, 3228 /*AEM_SETOPTIONS*/, 2 /*AECOOP_OR*/, 0x40 /*AECO_PASTESELECTCOLUMN*/);
            }
          }

          //Replace selection
          AkelPad.ReplaceSel(pResult);

          if (bAkelEdit)
          {
            if (nDirection & DN_SELECTION)
            {
              if (!(dwOptions & 0x40 /*AECO_PASTESELECTCOLUMN*/))
                AkelPad.SendMessage(hWndCurrentEdit, 3228 /*AEM_SETOPTIONS*/, 4 /*AECOOP_XOR*/, 0x40 /*AECO_PASTESELECTCOLUMN*/);
            }
          }

          if (nDirection & DN_SELECTION)
          {
            if (!AkelPad.SendMessage(hWndCurrentEdit, 3127 /*AEM_GETCOLUMNSEL*/, 0, 0))
              AkelPad.SetSel(nSelStart, nSelStart + pResult.length);
          }
          else AkelPad.SetSel(nInitialSelStart, nInitialSelEnd);
        }
        else AkelPad.SetSel(nInitialSelStart, nInitialSelEnd);

        RestoreScroll(hWndCurrentEdit, lpInitialScroll);
        SetRedraw(hWndCurrentEdit, true);

        if (nDirection & DN_ALLFILES)
        {
          //Next MDI frame
          AkelPad.SendMessage(hMainWnd, 273 /*WM_COMMAND*/, 4404 /*IDM_NONMENU_MDINEXT*/, 0);
          hWndCurrentEdit=AkelPad.GetEditWnd();
          if (hWndCurrentEdit != hWndInitialEdit)
          {
            AkelPad.SetSel(0, 0);
            continue;
          }
        }

        if (bShowCountOfChanges)
        {
          if (nDirection & DN_ALLFILES)
            AkelPad.MessageBox(hWndDialog, GetLangString(STRID_COUNTFILES) + nChangedFiles + "\n" + GetLangString(STRID_COUNTCHANGES) + nChanges, pScriptName, 64 /*MB_ICONINFORMATION*/);
          else
            AkelPad.MessageBox(hWndDialog, GetLangString(STRID_COUNTCHANGES) + nChanges, pScriptName, 64 /*MB_ICONINFORMATION*/);
        }
      }
    }
    catch (nError)
    {
      RestoreScroll(hWndCurrentEdit, lpInitialScroll);
      SetRedraw(hWndCurrentEdit, true);
      AkelPad.MessageBox(hWndDialog, nError.description, pScriptName, 16 /*MB_ICONERROR*/);
    }
    break;
  }
  return nResult;
}


//Functions
function SetWindowFontAndText(hWnd, hFont, pText)
{
  var lpWindowText;

  AkelPad.SendMessage(hWnd, 48 /*WM_SETFONT*/, hFont, true);

  if (lpWindowText=AkelPad.MemAlloc(256 * _TSIZE))
  {
    AkelPad.MemCopy(lpWindowText, pText.substr(0, 255), _TSTR);
    oSys.Call("user32::SetWindowText" + _TCHAR, hWnd, lpWindowText);

    AkelPad.MemFree(lpWindowText);
  }
}

function SetRedraw(hWnd, bRedraw)
{
  AkelPad.SendMessage(hWnd, 11 /*WM_SETREDRAW*/, bRedraw, 0);
  if (bRedraw) oSys.Call("user32::InvalidateRect", hWnd, 0, true);
}

function SaveScroll(hWnd)
{
  var lpPoint;

  if (lpPoint=AkelPad.MemAlloc(8 /*sizeof(POINT)*/, true))
    AkelPad.SendMessage(hWnd, 1245 /*EM_GETSCROLLPOS*/, 0, lpPoint);
  return lpPoint;
}

function RestoreScroll(hWnd, lpPoint)
{
  AkelPad.SendMessage(hWnd, 1246 /*EM_SETSCROLLPOS*/, 0, lpPoint);
  AkelPad.MemFree(lpPoint, true);
}

function RectToArray(lpRect, rcRect)
{
  rcRect.left=AkelPad.MemRead(lpRect, 3 /*DT_DWORD*/);
  rcRect.top=AkelPad.MemRead(lpRect + 4, 3 /*DT_DWORD*/);
  rcRect.right=AkelPad.MemRead(lpRect + 8, 3 /*DT_DWORD*/);
  rcRect.bottom=AkelPad.MemRead(lpRect + 12, 3 /*DT_DWORD*/);
  return rcRect;
}

function ArrayToRect(rcRect, lpRect)
{
  if (!lpRect)
    lpRect=AkelPad.MemAlloc(16 /*sizeof(RECT)*/);

  if (lpRect)
  {
    AkelPad.MemCopy(lpRect, rcRect.left, 3 /*DT_DWORD*/);
    AkelPad.MemCopy(lpRect + 4, rcRect.top, 3 /*DT_DWORD*/);
    AkelPad.MemCopy(lpRect + 8, rcRect.right, 3 /*DT_DWORD*/);
    AkelPad.MemCopy(lpRect + 12, rcRect.bottom, 3 /*DT_DWORD*/);
  }
  return lpRect;
}

function GetWindowPos(hWnd, hWndOwner, rcRect)
{
  var lpRect;
  var bResult=false;

  //Get rect
  if (lpRect=AkelPad.MemAlloc(16 /*sizeof(RECT)*/))
  {
    if (oSys.Call("user32::GetWindowRect", hWnd, lpRect))
    {
      RectToArray(lpRect, rcRect);
      rcRect.right-=rcRect.left;
      rcRect.bottom-=rcRect.top;

      if (hWndOwner)
        bResult=oSys.Call("user32::ScreenToClient", hWndOwner, lpRect);
      else
        bResult=true;
      rcRect.left=AkelPad.MemRead(lpRect, 3 /*DT_DWORD*/);
      rcRect.top=AkelPad.MemRead(lpRect + 4, 3 /*DT_DWORD*/);
    }
    AkelPad.MemFree(lpRect);
  }
  return bResult;
}

function CenterWindow(hWndParent, hWnd)
{
  var lpRect;
  var rcWndParent=[];
  var rcWnd=[];
  var X;
  var Y;

  if (lpRect=AkelPad.MemAlloc(16))  //sizeof(RECT)
  {
    if (!hWndParent)
      hWndParent=oSys.Call("user32::GetDesktopWindow");

    oSys.Call("user32::GetWindowRect", hWndParent, lpRect);
    RectToArray(lpRect, rcWndParent);

    oSys.Call("user32::GetWindowRect", hWnd, lpRect);
    RectToArray(lpRect, rcWnd);

    //Center window
    X=rcWndParent.left + ((rcWndParent.right - rcWndParent.left) / 2 - (rcWnd.right - rcWnd.left) / 2);
    Y=rcWndParent.top + ((rcWndParent.bottom - rcWndParent.top) / 2 - (rcWnd.bottom - rcWnd.top) / 2);

    oSys.Call("user32::SetWindowPos", hWnd, 0, X, Y, 0, 0, 0x15 /*SWP_NOZORDER|SWP_NOACTIVATE|SWP_NOSIZE*/);

    AkelPad.MemFree(lpRect);
  }
}

function ScrollLock(hWnd, bLock)
{
  AkelPad.SendMessage(hWnd, 3185 /*AEM_LOCKSCROLL*/, 3 /*SB_BOTH*/, bLock);
}

function ScrollCaret(hWnd)
{
  var lpStp;
  var dwScrollFlags=0;
  var dwScrollResult;

  if (lpStp=AkelPad.MemAlloc(20, true))  //sizeof(AESCROLLTOPOINT)
  {
    //Test scroll to caret
    dwScrollFlags=0x1|0x10|0x400|0x800 /*AESC_TEST|AESC_POINTCARET|AESC_OFFSETCHARX|AESC_OFFSETCHARY*/;
    AkelPad.MemCopy(lpStp, dwScrollFlags, 3 /*DT_DWORD*/, true);  //AESCROLLTOPOINT.dwFlags
    AkelPad.MemCopy(lpStp + 12, 1, 3 /*DT_DWORD*/, true);         //AESCROLLTOPOINT.nOffsetX
    AkelPad.MemCopy(lpStp + 16, 0, 3 /*DT_DWORD*/, true);         //AESCROLLTOPOINT.nOffsetY
    dwScrollResult=AkelPad.SendMessage(hWnd, 3183 /*AEM_SCROLLTOPOINT*/, 0, lpStp);

    dwScrollFlags=0x10 /*AESC_POINTCARET*/;
    if (dwScrollResult & 0x1 /*AECSE_SCROLLEDX*/)
      dwScrollFlags|=0x1000 /*AESC_OFFSETRECTDIVX*/;
    if (dwScrollResult & 0x2 /*AECSE_SCROLLEDY*/)
      dwScrollFlags|=0x2000 /*AESC_OFFSETRECTDIVY*/;

    //Scroll to caret
    AkelPad.MemCopy(lpStp, dwScrollFlags, 3 /*DT_DWORD*/, true);  //AESCROLLTOPOINT.dwFlags
    AkelPad.MemCopy(lpStp + 12, 3, 3 /*DT_DWORD*/, true);         //AESCROLLTOPOINT.nOffsetX
    AkelPad.MemCopy(lpStp + 16, 2, 3 /*DT_DWORD*/, true);         //AESCROLLTOPOINT.nOffsetY
    AkelPad.SendMessage(hWnd, 3183 /*AEM_SCROLLTOPOINT*/, 0, lpStp);

    AkelPad.MemFree(lpStp, true);
  }
}

function MakeLong(a, b)
{
  return ((a & 0xffff) | ((b & 0xffff) << 16));
}

function GetParent(pFile)
{
  var i;

  for (i=pFile.length - 1; i >= 0; --i)
  {
    if (pFile.charAt(i) == '\\')
      return pFile.substr(0, i);
  }
  return "";
}

function GetLangString(nStringID)
{
  var nLangID;

  nLangID=oSys.Call("kernel32::GetUserDefaultLangID");
  nLangID=nLangID & 0x3ff; //PRIMARYLANGID

  if (nLangID == 0x19) //LANG_RUSSIAN
  {
    if (nStringID == STRID_LOWJSCRIPT)
      return "\u0412\u0435\u0440\u0441\u0438\u044F\u0020\u004A\u0053\u0063\u0072\u0069\u0070\u0074\u0020\u043D\u0438\u0436\u0435\u002C\u0020\u0447\u0435\u043C\u0020\u0035\u002E\u0035\u002E";
    if (nStringID == STRID_WHAT)
      return "\u0427\u0442\u043E\u003A";
    if (nStringID == STRID_WITH)
      return "\u0427\u0435\u043C\u003A";
    if (nStringID == STRID_MATCHCASE)
      return "\u0423\u0447\u0438\u0442\u044B\u0432\u0430\u0442\u044C\u0020\u0440\u0435\u0433\u0438\u0441\u0442\u0440";
    if (nStringID == STRID_MULTILINE)
      return "\u041C\u043D\u043E\u0433\u043E\u0441\u0442\u0440\u043E\u0447\u043D\u043E";
    if (nStringID == STRID_ESCAPESEQ)
      return "\u0045\u0073\u0063\u002D\u043F\u043E\u0441\u043B\u0435\u0434\u043E\u0432\u0430\u0442\u0435\u043B\u044C\u043D\u043E\u0441\u0442\u0438";
    if (nStringID == STRID_FUNCTION)
      return "\u0417\u0430\u043C\u0435\u043D\u044F\u0442\u044C\u0020\u043D\u0430\u0020\u0444\u0443\u043D\u043A\u0446\u0438\u044E";
    if (nStringID == STRID_DIRECTION)
      return "\u041D\u0430\u043F\u0440\u0430\u0432\u043B\u0435\u043D\u0438\u0435";
    if (nStringID == STRID_FORWARD)
      return "\u0412\u043D\u0438\u0437";
    if (nStringID == STRID_BACKWARD)
      return "\u0412\u0432\u0435\u0440\u0445";
    if (nStringID == STRID_BEGINNING)
      return "\u0421\u0020\u043D\u0430\u0447\u0430\u043B\u0430";
    if (nStringID == STRID_INSEL)
      return "\u0412\u0020\u0432\u044B\u0434\u0435\u043B\u0435\u043D\u0438\u0438";
    if (nStringID == STRID_ALLFILES)
      return "\u0412\u0441\u0435\u0020\u0444\u0430\u0439\u043B\u044B";
    if (nStringID == STRID_FINDNEXT)
      return "\u041D\u0430\u0439\u0442\u0438\u0020\u0434\u0430\u043B\u0435\u0435";
    if (nStringID == STRID_REPLACE)
      return "\u0417\u0430\u043C\u0435\u043D\u0438\u0442\u044C";
    if (nStringID == STRID_REPLACEALL)
      return "\u0417\u0430\u043C\u0435\u043D\u0438\u0442\u044C\u0020\u0432\u0441\u0451";
    if (nStringID == STRID_CANCEL)
      return "\u041E\u0442\u043C\u0435\u043D\u0430";
    if (nStringID == STRID_SYNTAXERROR)
      return "\u0421\u0438\u043D\u0442\u0430\u043A\u0441\u0438\u0447\u0435\u0441\u043A\u0430\u044F\u0020\u043E\u0448\u0438\u0431\u043A\u0430\u003A\n \\\\ - \u043E\u0431\u0440\u0430\u0442\u043D\u044B\u0439\u0020\u0441\u043B\u044D\u0448\n \\r - \u043A\u043E\u043D\u0435\u0446\u0020\u0441\u0442\u0440\u043E\u043A\u0438\n \\t - \u0437\u043D\u0430\u043A\u0020\u0442\u0430\u0431\u0443\u043B\u044F\u0446\u0438\u0438";
    if (nStringID == STRID_FINISHED)
      return "\u041F\u043E\u0438\u0441\u043A\u0020\u0437\u0430\u0432\u0435\u0440\u0448\u0435\u043D\u002E";
    if (nStringID == STRID_COUNTFILES)
      return "\u0418\u0437\u043C\u0435\u043D\u0435\u043D\u043D\u044B\u0445\u0020\u0444\u0430\u0439\u043B\u043E\u0432\u003A\u0020";
    if (nStringID == STRID_COUNTCHANGES)
      return "\u041A\u043E\u043B\u0438\u0447\u0435\u0441\u0442\u0432\u043E\u0020\u0437\u0430\u043C\u0435\u043D\u003A\u0020";
  }
  else
  {
    if (nStringID == STRID_LOWJSCRIPT)
      return "JScript version is less than 5.5.";
    if (nStringID == STRID_WHAT)
      return "What:";
    if (nStringID == STRID_WITH)
      return "With:";
    if (nStringID == STRID_MATCHCASE)
      return "Case sensitive";
    if (nStringID == STRID_MULTILINE)
      return "Multiline";
    if (nStringID == STRID_ESCAPESEQ)
      return "Esc-sequences";
    if (nStringID == STRID_FUNCTION)
      return "Replace with function";
    if (nStringID == STRID_DIRECTION)
      return "Direction";
    if (nStringID == STRID_FORWARD)
      return "Down";
    if (nStringID == STRID_BACKWARD)
      return "Up";
    if (nStringID == STRID_BEGINNING)
      return "Beginning";
    if (nStringID == STRID_INSEL)
      return "In selection";
    if (nStringID == STRID_ALLFILES)
      return "All files";
    if (nStringID == STRID_FINDNEXT)
      return "Find next";
    if (nStringID == STRID_REPLACE)
      return "Replace";
    if (nStringID == STRID_REPLACEALL)
      return "Replace all";
    if (nStringID == STRID_CANCEL)
      return "Cancel";
    if (nStringID == STRID_SYNTAXERROR)
      return "Syntax error:\n \\\\ - backslash\n \\r - line feed\n \\t - tabulation";
    if (nStringID == STRID_FINISHED)
      return "Search finished.";
    if (nStringID == STRID_COUNTFILES)
      return "Changed files: ";
    if (nStringID == STRID_COUNTCHANGES)
      return "Count of changes: ";
  }
  return "";
}
