#ifndef _IDOCUMENT_H_
#define _IDOCUMENT_H_

// IDocument's VTable
#undef INTERFACE
#define INTERFACE IDocument
DECLARE_INTERFACE_ (INTERFACE, IDispatch)
{
  // IUnknown
  STDMETHOD_(HRESULT, Document_QueryInterface)(THIS_ REFIID, void **) PURE;
  STDMETHOD_(ULONG, Document_AddRef)(THIS) PURE;
  STDMETHOD_(ULONG, Document_Release)(THIS) PURE;

  // IDispatch
  STDMETHOD_(ULONG, Document_GetTypeInfoCount)(THIS_ UINT *) PURE;
  STDMETHOD_(ULONG, Document_GetTypeInfo)(THIS_ UINT, LCID, ITypeInfo **) PURE;
  STDMETHOD_(ULONG, Document_GetIDsOfNames)(THIS_ REFIID, LPOLESTR *, UINT, LCID, DISPID *) PURE;
  STDMETHOD_(ULONG, Document_Invoke)(THIS_ DISPID, REFIID, LCID, WORD, DISPPARAMS *, VARIANT *, EXCEPINFO *, UINT *) PURE;

  // IDocument methods
  STDMETHOD_(HRESULT, Document_GetMainWnd)(THIS_ int *) PURE;
  STDMETHOD_(HRESULT, Document_GetAkelDir)(THIS_ BSTR *) PURE;
  STDMETHOD_(HRESULT, Document_GetInstanceDll)(THIS_ int *) PURE;
  STDMETHOD_(HRESULT, Document_IsOldWindows)(THIS_ BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_IsOldRichEdit)(THIS_ BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_IsOldComctl32)(THIS_ BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_IsAkelEdit)(THIS_ BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_IsMDI)(THIS_ BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_GetEditWnd)(THIS_ int *) PURE;
  STDMETHOD_(HRESULT, Document_GetEditFile)(THIS_ HWND, BSTR *) PURE;
  STDMETHOD_(HRESULT, Document_GetEditCodePage)(THIS_ HWND, int *) PURE;
  STDMETHOD_(HRESULT, Document_GetEditBOM)(THIS_ HWND, BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_GetEditNewLine)(THIS_ HWND, int *) PURE;
  STDMETHOD_(HRESULT, Document_GetEditModified)(THIS_ HWND, BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_GetEditReadOnly)(THIS_ HWND, BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_SendMessage)(THIS_ int, UINT, WPARAM, LPARAM, LRESULT *) PURE;
  STDMETHOD_(HRESULT, Document_MessageBox)(THIS_ int, BSTR, BSTR, int, int *) PURE;
  STDMETHOD_(HRESULT, Document_InputBox)(THIS_ int, BSTR, BSTR, BSTR, BSTR *) PURE;
  STDMETHOD_(HRESULT, Document_GetSelStart)(THIS_ int *) PURE;
  STDMETHOD_(HRESULT, Document_GetSelEnd)(THIS_ int *) PURE;
  STDMETHOD_(HRESULT, Document_SetSel)(THIS_ int, int) PURE;
  STDMETHOD_(HRESULT, Document_GetSelText)(THIS_ int, BSTR *) PURE;
  STDMETHOD_(HRESULT, Document_ReplaceSel)(THIS_ BSTR) PURE;
  STDMETHOD_(HRESULT, Document_TextFind)(THIS_ HWND, BSTR, DWORD, int *) PURE;
  STDMETHOD_(HRESULT, Document_TextReplace)(THIS_ HWND, BSTR, BSTR, DWORD, BOOL, int *) PURE;
  STDMETHOD_(HRESULT, Document_GetClipboardText)(THIS_ BOOL, BSTR *) PURE;
  STDMETHOD_(HRESULT, Document_SetClipboardText)(THIS_ BSTR) PURE;
  STDMETHOD_(HRESULT, Document_Call)(THIS_ BSTR, SAFEARRAY **, LRESULT *) PURE;
  STDMETHOD_(HRESULT, Document_IsPluginRunning)(THIS_ BSTR, BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_OpenFile)(THIS_ BSTR, DWORD, int, BOOL, int *) PURE;
  STDMETHOD_(HRESULT, Document_ReadFile)(THIS_ BSTR, DWORD, int, BOOL, BSTR *) PURE;
  STDMETHOD_(HRESULT, Document_SaveFile)(THIS_ HWND, BSTR, int, BOOL, DWORD, int *) PURE;
  STDMETHOD_(HRESULT, Document_SystemFunction)(THIS_ IDispatch **) PURE;
  STDMETHOD_(HRESULT, Document_MemAlloc)(THIS_ DWORD, BOOL, int *) PURE;
  STDMETHOD_(HRESULT, Document_MemCopy)(THIS_ int, VARIANT, DWORD, BOOL, int *) PURE;
  STDMETHOD_(HRESULT, Document_MemRead)(THIS_ int, DWORD, BOOL, VARIANT *) PURE;
  STDMETHOD_(HRESULT, Document_MemFree)(THIS_ int, BOOL) PURE;
  STDMETHOD_(HRESULT, Document_WindowRegisterClass)(THIS_ BSTR, WORD *) PURE;
  STDMETHOD_(HRESULT, Document_WindowUnregisterClass)(THIS_ BSTR, BOOL *) PURE;
  STDMETHOD_(HRESULT, Document_WindowGetMessage)(THIS) PURE;
};

//Defines
#define DT_ANSI       0
#define DT_UNICODE    1
#define DT_WORD       2
#define DT_DWORD      3

typedef struct {
  IDocumentVtbl *lpVtbl;
  DWORD dwCount;
} IRealDocument;

typedef struct _POINTER {
  struct _POINTER *next;
  struct _POINTER *prev;
  void *lpString;
} POINTER;

typedef struct {
  BSTR wpCaption;
  BSTR wpLabel;
  BSTR wpEdit;
  BSTR *wpResult;
  HRESULT hr;
} INPUTBOX;

//Functions prototypes
HRESULT STDMETHODCALLTYPE Document_QueryInterface(IDocument *this, REFIID vTableGuid, void **ppv);
ULONG STDMETHODCALLTYPE Document_AddRef(IDocument *this);
ULONG STDMETHODCALLTYPE Document_Release(IDocument *this);

HRESULT loadRegTypeInfo(void);
ULONG STDMETHODCALLTYPE Document_GetTypeInfoCount(IDocument *this, UINT *pCount);
ULONG STDMETHODCALLTYPE Document_GetTypeInfo(IDocument *this, UINT itinfo, LCID lcid, ITypeInfo **pTypeInfo);
ULONG STDMETHODCALLTYPE Document_GetIDsOfNames(IDocument *this, REFIID riid, LPOLESTR *rgszNames, UINT cNames, LCID lcid, DISPID *rgdispid);
ULONG STDMETHODCALLTYPE Document_Invoke(IDocument *this, DISPID dispid, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS *params, VARIANT *result, EXCEPINFO *pexcepinfo, UINT *puArgErr);

void GetMainInfo();
void IsAkelPadReady();
BOOL GetEditInfo(HWND hWnd, EDITINFO *ei);
HRESULT STDMETHODCALLTYPE Document_GetMainWnd(IDocument *this, int *hWnd);
HRESULT STDMETHODCALLTYPE Document_GetEditWnd(IDocument *this, int *hWnd);
HRESULT STDMETHODCALLTYPE Document_GetAkelDir(IDocument *this, BSTR *wpDir);
HRESULT STDMETHODCALLTYPE Document_GetInstanceDll(IDocument *this, int *hInstance);
HRESULT STDMETHODCALLTYPE Document_IsOldWindows(IDocument *this, BOOL *bIsOld);
HRESULT STDMETHODCALLTYPE Document_IsOldRichEdit(IDocument *this, BOOL *bIsOld);
HRESULT STDMETHODCALLTYPE Document_IsOldComctl32(IDocument *this, BOOL *bIsOld);
HRESULT STDMETHODCALLTYPE Document_IsAkelEdit(IDocument *this, BOOL *bIsAkelEdit);
HRESULT STDMETHODCALLTYPE Document_IsMDI(IDocument *this, BOOL *bIsMDI);
HRESULT STDMETHODCALLTYPE Document_GetEditFile(IDocument *this, HWND hWnd, BSTR *wpFile);
HRESULT STDMETHODCALLTYPE Document_GetEditCodePage(IDocument *this, HWND hWnd, int *nCodePage);
HRESULT STDMETHODCALLTYPE Document_GetEditBOM(IDocument *this, HWND hWnd, BOOL *bBOM);
HRESULT STDMETHODCALLTYPE Document_GetEditNewLine(IDocument *this, HWND hWnd, int *nNewLine);
HRESULT STDMETHODCALLTYPE Document_GetEditModified(IDocument *this, HWND hWnd, BOOL *bModified);
HRESULT STDMETHODCALLTYPE Document_GetEditReadOnly(IDocument *this, HWND hWnd, BOOL *bReadOnly);
HRESULT STDMETHODCALLTYPE Document_SendMessage(IDocument *this, int hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT *lResult);
HRESULT STDMETHODCALLTYPE Document_MessageBox(IDocument *this, int hWnd, BSTR pText, BSTR pCaption, int nType, int *nResult);
HRESULT STDMETHODCALLTYPE Document_InputBox(IDocument *this, int hWnd, BSTR wpCaption, BSTR wpLabel, BSTR wpEdit, BSTR *wpResult);
BOOL CALLBACK InputBoxProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK InputBoxProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
HRESULT STDMETHODCALLTYPE Document_GetSelStart(IDocument *this, int *nSelStart);
HRESULT STDMETHODCALLTYPE Document_GetSelEnd(IDocument *this, int *nSelEnd);
HRESULT STDMETHODCALLTYPE Document_SetSel(IDocument *this, int nSelStart, int nSelEnd);
HRESULT STDMETHODCALLTYPE Document_GetSelText(IDocument *this, int nNewLine, BSTR *wpText);
HRESULT STDMETHODCALLTYPE Document_ReplaceSel(IDocument *this, BSTR wpText);
HRESULT STDMETHODCALLTYPE Document_TextFind(IDocument *this, HWND hWnd, BSTR wpFindIt, DWORD dwFlags, int *nResult);
HRESULT STDMETHODCALLTYPE Document_TextReplace(IDocument *this, HWND hWnd, BSTR wpFindIt, BSTR wpReplaceWith, DWORD dwFlags, BOOL bAll, int *nResult);
HRESULT STDMETHODCALLTYPE Document_GetClipboardText(IDocument *this, BOOL bAnsi, BSTR *wpText);
HRESULT STDMETHODCALLTYPE Document_SetClipboardText(IDocument *this, BSTR wpText);
HRESULT STDMETHODCALLTYPE Document_Call(IDocument *this, BSTR wpFunction, SAFEARRAY **psa, LRESULT *lResult);
HRESULT STDMETHODCALLTYPE Document_IsPluginRunning(IDocument *this, BSTR wpFunction, BOOL *bRunning);
HRESULT STDMETHODCALLTYPE Document_OpenFile(IDocument *this, BSTR wpFile, DWORD dwFlags, int nCodePage, BOOL bBOM, int *nResult);
HRESULT STDMETHODCALLTYPE Document_ReadFile(IDocument *this, BSTR wpFile, DWORD dwFlags, int nCodePage, BOOL bBOM, BSTR *wpText);
HRESULT STDMETHODCALLTYPE Document_SaveFile(IDocument *this, HWND hWnd, BSTR wpFile, int nCodePage, BOOL bBOM, DWORD dwFlags, int *nResult);
HRESULT STDMETHODCALLTYPE Document_SystemFunction(IDocument *this, IDispatch **objFunction);
HRESULT STDMETHODCALLTYPE Document_MemAlloc(IDocument *this, DWORD dwSize, BOOL bExeMemory, int *nPointer);
HRESULT STDMETHODCALLTYPE Document_MemCopy(IDocument *this, int nPointer, VARIANT vpData, DWORD dwType, BOOL bExeMemory, int *nBytes);
HRESULT STDMETHODCALLTYPE Document_MemRead(IDocument *this, int nPointer, DWORD dwType, BOOL bExeMemory, VARIANT *vpData);
HRESULT STDMETHODCALLTYPE Document_MemFree(IDocument *this, int nPointer, BOOL bExeMemory);
HRESULT STDMETHODCALLTYPE Document_WindowRegisterClass(IDocument *this, BSTR wpClassName, WORD *wAtom);
HRESULT STDMETHODCALLTYPE Document_WindowUnregisterClass(IDocument *this, BSTR wpClassName, BOOL *bResult);
HRESULT STDMETHODCALLTYPE Document_WindowGetMessage(IDocument *this);
HRESULT CallScriptFunction(IDispatch *objFunction, HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT *lResult);
LRESULT CALLBACK CallbackProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK CallbackProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

#endif

