#ifndef _ISERVER_H_
#define _ISERVER_H_

//GUID
extern const struct _GUID CLSID_IDocument;
extern const struct _GUID CLSID_TypeLib;
extern const struct _GUID IID_IDocument;
extern const struct _GUID IID_ISystemFunction;

//Global variables
extern DWORD g_nObjs;
extern DWORD g_nLocks;
extern IClassFactory MyIClassFactoryObj;

extern ITypeInfo *g_DocumentTypeInfo;
extern ITypeInfo *g_SystemFunctionTypeInfo;
extern const IClassFactoryVtbl MyIClassFactoryVtbl;
extern const IDocumentVtbl MyIDocumentVtbl;
extern const ISystemFunctionVtbl MyISystemFunctionVtbl;

extern IDispatch *g_objCallback;

//Functions prototypes
ULONG STDMETHODCALLTYPE classAddRef(IClassFactory *this);
HRESULT STDMETHODCALLTYPE classQueryInterface(IClassFactory *this, REFIID factoryGuid, void **ppv);
ULONG STDMETHODCALLTYPE classRelease(IClassFactory *this);
HRESULT STDMETHODCALLTYPE classCreateInstance(IClassFactory *this, IUnknown *punkOuter, REFIID vTableGuid, void **objHandle);
HRESULT STDMETHODCALLTYPE classLockServer(IClassFactory *this, BOOL flock);

HRESULT WINAPI DllGetClassObject(REFCLSID objGuid, REFIID factoryGuid, void **factoryHandle);
HRESULT WINAPI DllCanUnloadNow(void);
HRESULT WINAPI DllRegisterServer();
HRESULT WINAPI DllUnregisterServer();

void stringFromCLSIDA(char *szString, REFCLSID clsid);
HRESULT IsServerRegisteredA(HINSTANCE hInstance, REFCLSID clsid, const char *pNameTypeLib, const char *pNameProgID, const char *pObjectDescription, char *szDllFile, int nDllFileLen);
HRESULT RegisterServerA(HINSTANCE hInstance, REFCLSID clsid, const char *pNameTypeLib, const char *pNameProgID, const char *pObjectDescription);
HRESULT UnregisterServerA(REFCLSID clsid, REFGUID typelib, const char *pNameProgID);

#endif
