#ifndef _ISYSTEM_H_
#define _ISYSTEM_H_

// ISystemFunction's VTable
#undef INTERFACE
#define INTERFACE ISystemFunction
DECLARE_INTERFACE_ (INTERFACE, IDispatch)
{
  // IUnknown
  STDMETHOD_(HRESULT, SystemFunction_QueryInterface)(THIS_ REFIID, void **) PURE;
  STDMETHOD_(ULONG, SystemFunction_AddRef)(THIS) PURE;
  STDMETHOD_(ULONG, SystemFunction_Release)(THIS) PURE;

  // IDispatch
  STDMETHOD_(ULONG, SystemFunction_GetTypeInfoCount)(THIS_ UINT *) PURE;
  STDMETHOD_(ULONG, SystemFunction_GetTypeInfo)(THIS_ UINT, LCID, ITypeInfo **) PURE;
  STDMETHOD_(ULONG, SystemFunction_GetIDsOfNames)(THIS_ REFIID, LPOLESTR *, UINT, LCID, DISPID *) PURE;
  STDMETHOD_(ULONG, SystemFunction_Invoke)(THIS_ DISPID, REFIID, LCID, WORD, DISPPARAMS *, VARIANT *, EXCEPINFO *, UINT *) PURE;

  // ISystemFunction methods
  STDMETHOD_(HRESULT, SystemFunction_AddParameter)(THIS_ VARIANT) PURE;
  STDMETHOD_(HRESULT, SystemFunction_Call)(THIS_ BSTR, SAFEARRAY **, int *) PURE;
  STDMETHOD_(HRESULT, SystemFunction_GetLastError)(THIS_ DWORD *) PURE;
};

//Defines
typedef struct _SYSTEMFUNCTION {
  HSTACK hParametersStack;
  DWORD dwLastError;
} SYSTEMFUNCTION;

typedef struct _PARAMETER {
  struct _PARAMETER *next;
  struct _PARAMETER *prev;
  DWORD dwValue;
} PARAMETER;

typedef struct {
  ISystemFunctionVtbl *lpVtbl;
  DWORD dwCount;
  SYSTEMFUNCTION sf;
} IRealSystemFunction;

//Functions prototypes
HRESULT STDMETHODCALLTYPE SystemFunction_QueryInterface(ISystemFunction *this, REFIID vTableGuid, void **ppv);
ULONG STDMETHODCALLTYPE SystemFunction_AddRef(ISystemFunction *this);
ULONG STDMETHODCALLTYPE SystemFunction_Release(ISystemFunction *this);

HRESULT SystemFunction_LoadRegTypeInfo(void);
ULONG STDMETHODCALLTYPE SystemFunction_GetTypeInfoCount(ISystemFunction *this, UINT *pCount);
ULONG STDMETHODCALLTYPE SystemFunction_GetTypeInfo(ISystemFunction *this, UINT itinfo, LCID lcid, ITypeInfo **pTypeInfo);
ULONG STDMETHODCALLTYPE SystemFunction_GetIDsOfNames(ISystemFunction *this, REFIID riid, LPOLESTR *rgszNames, UINT cNames, LCID lcid, DISPID *rgdispid);
ULONG STDMETHODCALLTYPE SystemFunction_Invoke(ISystemFunction *this, DISPID dispid, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS *params, VARIANT *result, EXCEPINFO *pexcepinfo, UINT *puArgErr);

int CallProc(HSTACK *hStack, FARPROC lpProcedure);
HRESULT STDMETHODCALLTYPE SystemFunction_AddParameter(ISystemFunction *this, VARIANT vtParameter);
HRESULT STDMETHODCALLTYPE SystemFunction_Call(ISystemFunction *this, BSTR wpDllFunction, SAFEARRAY **psa, int *nResult);
HRESULT STDMETHODCALLTYPE SystemFunction_GetLastError(ISystemFunction *this, DWORD *dwLastError);

#endif
